#include "ColorPickerWindow.h"
#include "Colors.h"
#include "basLocale.h"
#include "TextDefs.h"

#define B_OK_BUTTON_MSG			0x98000
#define B_CANCEL_BUTTON_MSG		0x98001

BColorPickerWindow::BColorPickerWindow()
	: BWindow( BRect( -350, -110, 0, 0 ), "ColorPicker", B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_NOT_CLOSABLE ),
	Target(0), Msg(0)
{
	BView * view = new BView( Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0 );
	view->SetViewColor( BeBackgroundGrey );
	OkButton = new BButton( BRect( 300, 80, 340, 100), NULL, Locale->Text(TEXT_OK, "Ok"), new BMessage(B_OK_BUTTON_MSG));
	view->AddChild(OkButton);
	CancelButton = new BButton( BRect( 240, 80, 290, 100 ), NULL, Locale->Text(TEXT_CANCEL, "Cancel"), new BMessage(B_CANCEL_BUTTON_MSG));
	view->AddChild(CancelButton);
	ColorControl = new BColorControl( BPoint(5, 5), B_CELLS_32x8, 8, NULL, NULL, true );
	view->AddChild(ColorControl);
	AddChild(view);
}

BColorPickerWindow::~BColorPickerWindow()
{
}

void BColorPickerWindow::MessageReceived( BMessage *msg )
{
	switch ( msg->what )
	{
	case B_OK_BUTTON_MSG:
		if ( Msg && Target )
		{
			type_code tc;
			if ( Msg->GetInfo( "Color", &tc ) != B_NAME_NOT_FOUND )
			{
				if ( tc != B_INT32_TYPE )
				{
					Msg->RemoveData( "Color" );
					Msg->AddInt32( "Color", ColorControl->Value() );
				}
				else
				{
					Msg->ReplaceInt32( "Color", ColorControl->Value() );
				}
			}
			else
				Msg->AddInt32( "Color", ColorControl->Value() );
			Target->PostMessage(Msg);
			PostMessage(B_QUIT_REQUESTED);
		}
	case B_CANCEL_BUTTON_MSG:
		PostMessage(B_QUIT_REQUESTED);
		break;
	default:
		BWindow::MessageReceived(msg);
	}
}

bool BColorPickerWindow::QuitRequested()
{
	return true;
}

void BColorPickerWindow::SetTarget( BLooper *lo )
{
	Target = lo;
}

void BColorPickerWindow::SetColor( rgb_color c )
{
	ColorControl->SetValue(c);
}

void BColorPickerWindow::SetMessage( BMessage *msg )
{
	if ( Msg )
		delete Msg;
	Msg = msg;
}