#ifndef __basApplication_h_
#define __basApplication_h__

#include <Application.h>

class basWindow;

class basApplication : public BApplication
{
public:
	basApplication();
	virtual ~basApplication();

	virtual void MessageReceived( BMessage* );
	virtual void ReadyToRun();
	virtual void RefsReceived( BMessage* );
	virtual bool QuitRequested();

	void SetSettingBool( const char *field, bool );
	void SetSettingInt( const char *field, int );
	void SetSettingString( const char *field, char * );
	void SetSettingFloat( const char *field, float );
	void SetSettingPoint( const char *field, BPoint );
	void GetSettingBool( const char *field, bool *);
	void GetSettingInt( const char *field, int *);
	void GetSettingString( const char *field, char ** );
	void GetSettingFloat( const char *field, float *);
	void GetSettingPoint( const char *field, BPoint *);

	BMessage *Settings() { return GlobalSettings; }

	void SaveSettings();

	bool fQuiting;
	bool isRegistered;
private:
	void BuildDefaultSettings();
	basWindow *mainWindow;
	BMessage *GlobalSettings;
};

#endif