#ifndef __basImageList_h__
#define __basImageList_h__

#include <Window.h>
#include <List.h>
#include <ListView.h>
#include <MenuBar.h>
#include <Entry.h>
#include <Directory.h>
#include "BetterScrollView.h"
#include "basPlugin.h"
#include "basCommon.h"

class basWindow;

class basImageListList : public BListView
{
public:
	basImageListList( BRect, const char *, list_view_type, uint32);

	virtual void MessageReceived( BMessage *msg);
};

class basImageListWindow : public BWindow
{
public:
	basImageListWindow(basWindow *);
	~basImageListWindow();

	virtual void MessageReceived( BMessage *);
	virtual bool QuitRequested();
	virtual void FrameResized(float, float);
	void AddRef( entry_ref * );
	void OpenImageList( BEntry * );
	void SaveImageList( BEntry * );
	void ClearImageList();
	virtual void RefsReceived( BMessage* );

private:
	basWindow *MainWindow;
	BList *imageList;
	basImageListList *imageListView;
	BetterScrollView *imageListScrollView;
	BMenuBar *MenuBar;
	int *Filters;
	int numFilters;
};

#endif