#include <View.h>
#include <Screen.h>
#include <Roster.h>
#include "basNagScreen.h"
#include "basCommon.h"
#include "Colors.h"

basNagScreenView::basNagScreenView(BRect rect)
	: BView( rect, NULL, B_FOLLOW_ALL, B_PULSE_NEEDED|B_WILL_DRAW )
{
	OkButton = new BButton( BRect( 310, 155, 395, 180 ), NULL, "Continue", new BMessage(B_BUTTON_OK), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
	OkButton->SetEnabled(false);

	AddChild(OkButton);

	GoToBebits = new BButton( BRect( 70, 155, 305, 180 ), NULL, "Go To bebits.com to Purchase BeAndSee", new BMessage(B_BUTTON_PURCHASE), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW );
	GoToBebits->SetEnabled(false);

	AddChild(GoToBebits);

	SetLowColor(BeBackgroundGrey);
	SetFontSize(10);
}

void basNagScreenView::Pulse()
{
	OkButton->SetEnabled(true);
	GoToBebits->SetEnabled(true);
	Window()->SetPulseRate(0);
}

void basNagScreenView::Draw(BRect)
{
	DrawString("Hello and welcome to BeAndSee.", BPoint(10, 15) );
	DrawString("This a trial version of BeAndSee. Although it isn\'t crippled of nag screens or lack", BPoint(10, 30));
	DrawString("of features it still is a trial version.", BPoint(10, 45));
	DrawString("If you like this application and would like to contribute for the author and the", BPoint(10, 60));
	DrawString("BeOS community please buy the full version. (for more instructions about", BPoint(10, 75));
	DrawString("purchasing BeAndSee please read the README file that is bundled with the", BPoint(10, 90));
	DrawString("distribution).", BPoint(10, 105));
	DrawString("By buying BeAndSee you're contributing for the future of BeOS development", BPoint(10, 120));
	DrawString("and for the quantity and quality of BeOS Software, please buy the full version", BPoint(10, 135));
	DrawString("to contribute. Thank You.", BPoint(10, 150) );
}

basNagScreenWindow::basNagScreenWindow()
	: BWindow( BRect( 0, 0, 400, 185 ), "BeAndSee's NagScreen", B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE|B_NOT_ZOOMABLE|B_NOT_CLOSABLE )
{
	basNagScreenView *view = new basNagScreenView(Bounds() );
	view->SetViewColor(BeBackgroundGrey);

	AddChild(view);

	BScreen screen;
	MoveTo( (screen.Frame().Width() - Bounds().Width()) / 2, (screen.Frame().Height() - Bounds().Height()) / 2 );

	Show();

	SetPulseRate(10000000);
}

void basNagScreenWindow::MessageReceived(BMessage *msg)
{
	switch (msg->what)
	{
		case B_BUTTON_OK:
			PostMessage(B_QUIT_REQUESTED);
			break;
		case B_BUTTON_PURCHASE:
			{
				char *url = "http://www.bebits.com/product/36";
				be_roster->Launch("application/x-vnd.Be.URL.http", 1, &url);
				PostMessage(B_QUIT_REQUESTED);
			}
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}

bool basNagScreenWindow::QuitRequested()
{
	return true;
}