#include <unistd.h>
#include <string.h>
#include <Directory.h>
#include <Path.h>
#include <List.h>
#include <Roster.h>
#include <Application.h>
#include <stdio.h>
#include "basPluginInterface.h"
#include "basBitmapWorker.h"

basPluginInterfaceManager::basPluginInterfaceManager()
{
}

basPluginInterfaceManager::~basPluginInterfaceManager()
{
	for ( unsigned int i=0; i<PluginBList.size(); i++ )
	{
		delete PluginBList[i]->Ref;
		delete PluginBList[i]->Plug;
		unload_add_on( PluginBList[i]->AddOn_ID);
		delete PluginBList[i];
	}
}

void basPluginInterfaceManager::LoadPlugins(const char *fromwhere)
{
	char temp[B_PATH_NAME_LENGTH];
	if ( !fromwhere )
	{
		app_info info;
		be_app->GetAppInfo(&info);
		BEntry ent(&info.ref, true);
		BEntry par;
		ent.GetParent(&par);
		BPath path(&par);
		sprintf(temp, "%s/plugins", path.Path() );
		fromwhere = (const char*)temp;
	}

	BDirectory dir( fromwhere );
	BEntry entry;

	while ( dir.GetNextEntry( &entry, true) == B_OK )
	{
		if ( !entry.IsDirectory() )
		{
			BPath path(&entry);
			image_id iid = load_add_on( path.Path() );
			if ( iid >= 0 )
			{
				basPlugin *(*get_plugin)( unsigned int);
				basPlugin *plug;
				if ( get_image_symbol( iid, "ReturnPlugin", B_SYMBOL_TYPE_TEXT, (void**)&get_plugin) == B_OK )
				{
					plug = get_plugin(PLUGIN_CURRENT_API_VERSION);
					if ( plug )
					{
						basPluginInterface *pi = new basPluginInterface;
						pi->AddOn_ID = iid;
						pi->Plug = plug;
						pi->Ref = new entry_ref;
						get_ref_for_path( path.Path(), pi->Ref);
						PluginBList.push_back(pi);
					}
				}
				else
					unload_add_on(iid);
			}
		}
	}
}

vector<basPluginInterface*>& basPluginInterfaceManager::PluginList()
{
	return PluginBList;
}