#ifndef __basPreferencesWindow_h__
#define __basPreferencesWindow_h__

#include <View.h>
#include <Window.h>
#include <MenuField.h>
#include <Box.h>
#include <String.h>
#include <Message.h>
#include <TextControl.h>

class BColorShowControl : public BView
{
public:
	BColorShowControl(BRect, const char *, const char *, BMessage *, uint32, uint32 );
	virtual void Draw(BRect);
	virtual void MouseDown(BPoint);
	void SetValue(rgb_color c) { Value = c; Invalidate(); }

private:
	BString Label;
	BMessage *Message;
	rgb_color Value;
};

class basPreferencesWindow : public BWindow
{
public:
	basPreferencesWindow( BWindow *);
	~basPreferencesWindow();

	virtual void MessageReceived( BMessage *msg );
	virtual bool QuitRequested();

private:
	BView *backView;
	BBox *boxFL, *boxTV, *boxGeneralOptions, *boxColors;
	BMenuField *menuFLL, *menuFLM, *menuFLW;
	BMenuField *menuTVL, *menuTVM, *menuTVR, *menuTVW, *menuTVD;
	BMenuField *Languages;
	BMenuField *TumbnailCachingEnabled;
	BColorShowControl *controlColor1;
	BTextControl *PreferedAppTC;
	BWindow *ParentWindow;
};

#endif