#include <Message.h>
#include <View.h>
#include <Alert.h>
#include <ScrollView.h>
#include <string.h>
#include "basSendEmailWindow.h"
#include "basLocale.h"
#include "TextDefs.h"
#include "Colors.h"
#include "basCommon.h"
#include "basLocale.h"
#include "TextDefs.h"

basSendEmailWindow::basSendEmailWindow(const char *enclosure)
	: BWindow( BRect( 100, 100, 400, 505 ), Locale->Text(TEXT_BEANDSEE_SEND_IMAGE_BY_EMAIL, "BeAndSee's Send Image by E-Mail"), B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE|B_NOT_ZOOMABLE )
{
	BView *back = new BView(Bounds(), NULL, B_FOLLOW_ALL, 0);
	back->SetViewColor(BeBackgroundGrey);

	FromText = new BTextControl( BRect( 5, 5, 295, 30 ), NULL, Locale->Text( TEXT_FROM, "From:"), "", NULL );
	FromText->SetDivider( 50 );
	back->AddChild(FromText);
	ToText = new BTextControl( BRect( 5, 35, 295, 60 ), NULL, Locale->Text( TEXT_TO, "To:"), "", NULL );
	ToText->SetDivider( 50 );
	back->AddChild(ToText);
	CCText = new BTextControl( BRect( 5, 65, 295, 90 ), NULL, Locale->Text( TEXT_CC, "CC:"), "", NULL );
	CCText->SetDivider( 50 );
	back->AddChild(CCText);
	BCCText = new BTextControl( BRect( 5, 95, 295, 120 ), NULL, Locale->Text( TEXT_BCC, "BCC:"), "", NULL );
	BCCText->SetDivider( 50 );
	back->AddChild(BCCText);
	SubjectText = new BTextControl( BRect( 5, 125, 295, 150 ), NULL, Locale->Text( TEXT_SUBJECT, "Subject:"), "", NULL );
	SubjectText->SetDivider( 50 );
	back->AddChild(SubjectText);

	MessageString = new BStringView( BRect( 5, 155, 295, 165 ), NULL, Locale->Text( TEXT_MESSAGE, "Message:") );
	back->AddChild( MessageString );

	MessageText = new BTextView( BRect( 5, 170, 295 - B_V_SCROLL_BAR_WIDTH, 370 ), NULL, BRect( 0, 0, 290 - B_V_SCROLL_BAR_WIDTH, 200), 0);
	back->AddChild(new BScrollView(NULL, MessageText, 0, 0, false, true));

	SendNowButton = new BButton( BRect( 215, 375, 295, 400 ), NULL, Locale->Text( TEXT_SEND_NOW, "Send Now"), new BMessage( B_BUTTON_SEND_NOW ) );
	back->AddChild(SendNowButton);
	SendButton = new BButton( BRect( 150, 375, 210, 400), NULL, Locale->Text( TEXT_SEND, "Send"), new BMessage(B_BUTTON_OK) );
	back->AddChild(SendButton);
	CancelButton = new BButton( BRect( 85, 375, 145, 400), NULL, Locale->Text( TEXT_CANCEL, "Cancel"), new BMessage(B_BUTTON_CANCEL) );
	back->AddChild(CancelButton);

	AddChild(back);

	Enclosure = new char[strlen(enclosure)+1];
	strcpy( Enclosure, enclosure );

	Show();
}

basSendEmailWindow::~basSendEmailWindow()
{
	delete Enclosure;
}

void basSendEmailWindow::MessageReceived( BMessage *msg )
{
	switch ( msg->what )
	{
		case B_BUTTON_SEND_NOW:
			if ( SendMail(true) )
				PostMessage(B_QUIT_REQUESTED);
			break;
		case B_BUTTON_OK:
			if ( SendMail(false) )
				PostMessage(B_QUIT_REQUESTED);
			break;
		case B_BUTTON_CANCEL:
			PostMessage(B_QUIT_REQUESTED);
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}

bool basSendEmailWindow::QuitRequested()
{
	PostMessage(B_QUIT_REQUESTED);
	return true;
}

bool basSendEmailWindow::SendMail(bool now)
{
	if ( strlen( ToText->Text() ) <= 0 )
	{
		(new BAlert( Locale->Text( TEXT_WARNING, "Warning" ), Locale->Text( TEXT_NEED_TO_FILL_THE_TO_FIELD, "You must fill the To field."), Locale->Text(TEXT_OK, "Ok") ) )->Go();
		return false;
	}
	mail_message.AddHeaderField( B_MAIL_TO, ToText->Text() );
	mail_message.AddHeaderField( B_MAIL_SUBJECT, SubjectText->Text() );
	if ( strlen( CCText->Text() ) <= 0 )
		mail_message.AddHeaderField( B_MAIL_CC, CCText->Text() );
	if ( strlen( BCCText->Text() ) <= 0 )
		mail_message.AddHeaderField( B_MAIL_BCC, BCCText->Text() );
	if ( strlen( FromText->Text() ) <= 0 )
		mail_message.AddHeaderField( B_MAIL_FROM, FromText->Text() );
	mail_message.Send( now );
	mail_message.AddContent( MessageText->Text(), strlen(MessageText->Text()) );
	mail_message.AddEnclosure( Enclosure );
	return true;
}