#ifndef __basSupport_h__
#define __basSupport_h__

#include <string.h>

template <class _tP>
class basStack
{
public:
	basStack( unsigned int size)
		: stack_frame_size(size), deleteOnOverflow(false)
	{
		stack_frame = new _tP[stack_frame_size];
		for ( unsigned int i=0; i<stack_frame_size; i++)
		{
			stack_frame[i] = 0;
		}
	}

	virtual ~basStack()
	{
		delete [] stack_frame;
	}

	virtual void Push( _tP p)
	{
		if ( stack_frame[stack_frame_size-1] )
			Overflow(stack_frame[stack_frame_size-1]);
		memmove( &stack_frame[1], &stack_frame[0], sizeof(_tP)*stack_frame_size-1);
		stack_frame[0] = p;
	}

	virtual _tP Pop()
	{
		return 0;
	}

	void SetDeleteOnOverflow( bool f )
	{
		deleteOnOverflow = f;
	}

protected:
	virtual void Overflow( _tP )
	{
	}

	_tP *stack_frame;
	unsigned int stack_frame_size;
	bool deleteOnOverflow;
};

#endif