#ifndef __basTreeView_h__
#define __basTreeView_h__

#include "CLVListItem.h"
#include "ColumnListView.h"
#include <String.h>
#include <Node.h>
#include <Entry.h>
#include <List.h>
#include <vector>

class basTreeView;

class basTreeItem : public CLVListItem
{
public:
	basTreeItem( BBitmap *, const char *, node_ref &, entry_ref &, bool super = false, int level = 0, int type = 0 );
	basTreeItem( BBitmap *, const char *, bool super = false, int level = 0, int type = 0, int arg = 0 );

	void DrawItemColumn( BView *owner, BRect draw_rect, int32 column_index, bool complete );
	void Update( BView *owner, const BFont *font );

	entry_ref &Ref() { return EntryRef; }
	int GetType() { return Type; }
	int GetArg() { return Arg; }

private:
friend class basTreeView;
	BBitmap *Bitmap;
	BString Text;
	float FontHeight, fTextOffset;
	bool ExpandedOnce;
	node_ref NodeRef;
	entry_ref EntryRef;
	int Type;
	int Arg;
};

typedef struct
{
	basTreeItem *Item;
	dev_t Dev;
} DevItem;

class basTreeView : public ColumnListView
{
public:
	basTreeView( );
	virtual ~basTreeView();

	CLVContainerView *Container() { return ContainerView; };

	virtual void Expand(CLVListItem* item);
	virtual void FrameResized(float, float);
	void GoTo( entry_ref & );

	void RemoveVolume( dev_t );
	void AddVolume( dev_t );

private:
	static int32 ExpandThread( void * );

	CLVContainerView *ContainerView;
	BList openThreadList;

	vector<DevItem*> MountList;
};

#endif