#include <File.h>
#include <stdio.h>
#include <Alert.h>
#include <string.h>
#include <Path.h>
#include <BitmapStream.h>
#include <TranslatorRoster.h>
#include "htmlgenerator.h"
#include "basHTMLConfig.h"

basHTMLConfig::basHTMLConfig(basHTMLGentPlugin *plug, BMessage *msg)
	: BWindow( BRect(100, 100, 400, 165), "BeAndSee HTML generator Plugin", B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE|B_NOT_ZOOMABLE ),
	Plug(plug), refsList(msg)
{
	backView = new BView( Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0 );
	backView->SetViewColor( BeBackgroundGrey );

	SavePanel = new BFilePanel( B_SAVE_PANEL, new BMessenger(this), NULL, B_FILE_NODE, false, NULL, NULL, true, true );
	SavePanel->SetButtonLabel( B_DEFAULT_BUTTON, "Ok" );
	SavePanel->SetSaveText("index.html");

	OkButton = new BButton( BRect( 240, 35, 295, 60), NULL, "Ok", new BMessage(B_BUTTON_OK));
	backView->AddChild(OkButton);
	CancelButton = new BButton( BRect( 180, 35, 235, 60), NULL, "Cancel", new BMessage(B_BUTTON_CANCEL));
	backView->AddChild(CancelButton);

	htmlFilePath = new BTextControl( BRect(5, 5, 235, 30), NULL, "HTML File", NULL, NULL);
	htmlFilePath->SetDivider( htmlFilePath->StringWidth("HTML File") + 5 );
	backView->AddChild(htmlFilePath);

	ChooseHTMLFileButton = new BButton( BRect( 240, 5, 295, 25 ), NULL, "Browse..", new BMessage(B_MENU_SAVE));
	backView->AddChild( ChooseHTMLFileButton);

	AddChild(backView);
	Show();
}

void basHTMLConfig::MessageReceived( BMessage *msg)
{
	switch ( msg->what )
	{
		case B_BUTTON_CANCEL:
			QuitRequested();
			break;
		case B_BUTTON_OK:
			{
				if ( strlen( htmlFilePath->Text() ) > 0 )
				{
					if ( Plug->GenerateHTML(refsList, htmlFilePath->Text()) )
						QuitRequested();
				}
				else
				{
					(new BAlert("Warning", "You should specify the HTML file you want to write to.", "Ok.."))->Go();
				}
			}
			break;
		case B_MENU_SAVE:
			SavePanel->Show();
			break;
		case B_SAVE_REQUESTED:
			{
				entry_ref dirref;
				const char *name;
				char path[B_FILE_NAME_LENGTH];
				msg->FindRef( "directory", &dirref);
				BEntry ent(&dirref);
				BPath pth(&ent);
				strcpy( path, pth.Path() );
				msg->FindString( "name", &name );
				strcat(path, "/");
				strcat(path, name);
				htmlFilePath->SetText(path);
			}
			break;
		default:
			BWindow::MessageReceived(msg);
	}
}

bool basHTMLConfig::QuitRequested()
{
	PostMessage(B_QUIT_REQUESTED);
	Plug->htmlConfig = NULL;
	return true;
}