#include <Window.h>
#include <RadioButton.h>
#include <Button.h>
#include <Bitmap.h>
#include "basPlugin.h"
#include "basCommon.h"
#include "Colors.h"

class basCropWindow : public BWindow
{
public:
	basCropWindow( BBitmap *sc, BBitmap **wb )
		: BWindow( BRect(100, 100, 200, 225), "Rotate Plugin", B_TITLED_WINDOW_LOOK, B_MODAL_APP_WINDOW_FEEL, B_NOT_RESIZABLE|B_NOT_ZOOMABLE ),
			SourceBitmap(sc), WorkBitmap(wb)
	{
		BView *view = new BView( Bounds(), NULL, B_FOLLOW_ALL_SIDES, 0 );
		view->SetViewColor( BeBackgroundGrey );

		n90D = new BRadioButton( BRect( 5, 5, 95, 30), NULL, "90 Degrees", NULL );
		n90D->SetValue(1);
		view->AddChild(n90D);

		n180D = new BRadioButton( BRect( 5, 35, 95, 60), NULL, "180 Degrees", NULL );
		view->AddChild(n180D);

		n270D = new BRadioButton( BRect( 5, 65, 95, 90), NULL, "270 Degrees", NULL );
		view->AddChild(n270D);

		OkButton = new BButton( BRect( 50, 95, 95, 120), NULL, "Ok", new BMessage(B_BUTTON_OK));
		view->AddChild(OkButton);

		did_it = false;

		AddChild(view);
		Show();
	}

	virtual void MessageReceived( BMessage *msg )
	{
		switch (msg->what)
		{
		case B_BUTTON_OK:
			{
				int action = n90D->Value() == 1 ? 1 : n180D->Value() == 1 ? 2 : 3;

				unsigned int *dpointer;
				unsigned int *spointer = (unsigned int*)SourceBitmap->Bits();
				int _x = SourceBitmap->Bounds().IntegerWidth()+1;
				int _y = SourceBitmap->Bounds().IntegerHeight()+1;

				switch ( action )
				{
					case 1:
					{
						*WorkBitmap = new BBitmap( BRect(0, 0, _y-1, _x-1), B_RGBA32 );
						if ( *WorkBitmap )
						{
							dpointer = (unsigned int*)(*WorkBitmap)->Bits();

							for ( int i=0; i<_y; i++)
							{
								for ( int j=0; j<_x; j++)
								{
									dpointer[ j * _y + _y - i - 1] = spointer[ i * _x + j ];
								}
							}
							did_it = true;
						}
					}
					break;
					case 2:
					{
						*WorkBitmap = new BBitmap( BRect(0, 0, _x-1, _y-1), B_RGBA32 );
						if ( *WorkBitmap )
						{
							dpointer = (unsigned int*)(*WorkBitmap)->Bits();

							for ( int i=0; i<_y; i++)
							{
								for ( int j=0; j<_x; j++)
								{
									dpointer[ ( _y - i -1 ) * _x + j ] = spointer[ i * _x + j ];
								}
							}
							did_it = true;
						}
					}
					break;
					case 3:
					{
						*WorkBitmap = new BBitmap( BRect(0, 0, _y-1, _x-1), B_RGBA32 );
						if ( *WorkBitmap )
						{
							dpointer = (unsigned int*)(*WorkBitmap)->Bits();

							for ( int i=0; i<_y; i++)
							{
								for ( int j=0; j<_x; j++)
								{
									dpointer[ ( _x - j - 1 ) * _y + i ] = spointer[ i * _x + j ];
								}
							}
							did_it = true;
						}
					}
					break;
				}

				PostMessage(B_QUIT_REQUESTED);
			}
			break;
		default:
			BWindow::MessageReceived(msg);
		}
	}

	virtual bool QuitRequested()
	{
		if (!did_it)
		{
			delete *WorkBitmap;
			*WorkBitmap = NULL;
		}
		return true;
	}
private:
	BBitmap *SourceBitmap, **WorkBitmap;
	BButton *OkButton;
	BRadioButton *n90D, *n180D, *n270D;
	bool did_it;
};

class basCropPlugin : public basPlugin
{
public:
	basCropPlugin(unsigned int);

	virtual int ProcessImage( BBitmap *, BBitmap ** );
	virtual int ProcessRefs( BMessage *)
	{
		return -1;
	}

	virtual void Configure()
	{
	}

	virtual const char *PluginName() { return "Rotate Plugin"; };
	virtual const int PluginVersion() { return ((0 << 24) | (1 << 16) | ( 0 << 8 ) | 0 ); };
	virtual const int PluginType() { return PLUGIN_TYPE_PROCESS_IMAGE; }
};

basCropPlugin::basCropPlugin(unsigned int params)
	: basPlugin(params)
{

}

int basCropPlugin::ProcessImage( BBitmap *SourceBitmap, BBitmap **out )
{
	basCropWindow *wnd = new basCropWindow( SourceBitmap, out );
	status_t status;
	wait_for_thread(wnd->Thread(), &status);

	return 0;
}

extern "C" basPlugin* ReturnPlugin( unsigned int params)
{
	return new basCropPlugin(params);
}

int main()
{
	return 0;
}